#include <stdio.h>
#include <avr/io.h>
#include <string.h>
#include <avr/pgmspace.h>
#include "hw_eth.h"
#include "logger.h"
#include "DOS/dos.h"
#include "DOS/dir.h"



void uart0_init(void)
{
	// Baudrate 4800
	//UBRR0L = 208;
	
	// Baudrate 9600
	//UBRR0L = 103;

	// Baudrate 38400
	UBRR0L = 26;

	// Baudrate 115200
	//UBRR0L = 3;

	// Datenbyte 8
  UCSR0C |= (1 << UCSZ00);
  UCSR0C |= (1 << UCSZ01);
	// Parity keine
	UCSR0C &= ~(1 << UPM00);
	UCSR0C &= ~(1 << UPM01);
	// Stoppbit 1
	UCSR0C &= ~(1 << USBS0); 
	// Asynchronous Operation
	UCSR0C &= ~(1 << UMSEL0);
	UCSR0C &= ~(1 << UCPOL0);  

//	UCSR0B |= (1 << RXCIE); // Interrupt enabel fr RXC flag
	UCSR0B |= (1 << RXEN0);  // Receive Enable
	UCSR0B |= (1 << TXEN0);  // Transmitter Enable

}

void uart1_init(void)
{
	
	// Baudrate 9600
	UBRR1L = 103;

	// Datenbyte 8
  UCSR1C |= (1 << UCSZ10);
  UCSR1C |= (1 << UCSZ11);
	// Parity keine
	UCSR1C &= ~(1 << UPM10);
	UCSR1C &= ~(1 << UPM11);
	// Stoppbit 1
	UCSR1C &= ~(1 << USBS1); 
	// Asynchronous Operation
	UCSR1C &= ~(1 << UMSEL1);
	UCSR1C &= ~(1 << UCPOL1);  

//	UCSR1B |= (1 << RXCIE1); // Interrupt enabel fr RXC flag
	UCSR1B |= (1 << RXEN1);  // Receive Enable
	UCSR1B |= (1 << TXEN1);  // Transmitter Enable

}

// Einzelnes Zeichen senden
void rs232_putc (char *buffer)
{
   while ( !(UCSR0A & (1<<UDRE0)));           
   UDR0 = *buffer;                           		//Daten senden
   while ( !(UCSR0A & (1<<TXC0)));            	//Warten bis Senden abgeschlossen
}

void rs232_puts (char *s)
{ 
   while (*s != '\0')
   {
	    while ( !(UCSR0A & (1<<UDRE0)));   	
      	UDR0 = *s;                           		//Zeichen nach Sendedatenregister                         
 	  	s++;																			//Adresse erhhen
   }  	
   while ( !(UCSR0A & (1<<UDRE0)));  
   UDR0 = '\n';   
   while ( !(UCSR0A & (1<<TXC0)));            	//Warten bis Senden abgeschlossen
} 


void rs232_puts_P(PGM_P s)
{
	unsigned char c;
   while ( (c = pgm_read_byte(s++)) != '\0')
   {
      while ( !(UCSR0A & (1<<UDRE0)));         //Warten bis UDR leer ist fr Senden
      UDR0 = c;
   }    
   while ( !(UCSR0A & (1<<UDRE0)));  
   UDR0 = '\n';   
   while ( !(UCSR0A & (1<<TXC0)));            	//Warten bis Senden abgeschlossen
}

void rs232_put_uint16(unsigned int c){
	unsigned int tmp;
	unsigned int mul;
	unsigned char l;
	
	l=0;
	for(mul=10000; mul>0; mul = mul/10){
		tmp = '0';
		while(c>=mul){
			c -= mul;
			tmp++;
			l=1;
		}
		if (l==0 && tmp == '0' && mul!=1)
			rs232_putc(' ');
		else
			rs232_putc(tmp);
	}
}

void rs232_put_uint8(unsigned char c){
	unsigned int tmp;
	unsigned char mul;
	unsigned char l;
	
	l=0;	
	for(mul=100; mul>0; mul = mul/10){
		tmp = '0';
		while(c>=mul){
			c -= mul;
			tmp++;
			l=1;
		}
		if (l==0 && tmp == '0' && mul!=1)
			rs232_putc(' ');
		else
			rs232_putc(tmp);
	}
}



void rs232_puts1 (char *s)
{ 
   while (*s != '\0')
   {
	    while ( !(UCSR1A & (1<<UDRE1)));   	
      	UDR1 = *s;                           		//Zeichen nach Sendedatenregister                         
 	  	s++;									//Adresse erhhen
   }  	
   while ( !(UCSR1A & (1<<UDRE1)));  
   UDR1=*s;
   while ( !(UCSR1A & (1<<TXC1)));            	//Warten bis Senden abgeschlossen
} 


/****************************************************/




/*



int log(unsigned char *string)
{
	// /CS fr SD-Karte aktivieren
	cs_sd_activate();
	//SD Initialisierung  
	MMC_IO_Init();        
	GetDriveInformation();
	Fclose();                     

	//String abspeichern
	if(Fopen("debug.txt",F_WRITE)==F_OK)
 	{
 		Fwrite("/r/n",2);
  	Fwrite(string,strlen(string));
  	Fclose();
  }
  else 
  {
  	// /CS fr SD-Karte deaktivieren
		cs_sd_deactivate();
  	return 1;
  }
  
  // /CS fr SD-Karte deaktivieren
	cs_sd_deactivate();
  return 0;
} 
*/